diff --git a/openbsc/src/gsm_04_08.c b/openbsc/src/gsm_04_08.c
index eeabc0f..3bc163e 100644
--- a/openbsc/src/gsm_04_08.c
+++ b/openbsc/src/gsm_04_08.c
@@ -3539,6 +3539,7 @@ static int gsm0408_rcv_cc(struct msgb *msg)
 					     GSM48_MT_CC_RELEASE_COMPL);
 			return -ENOMEM;
 		}
+		subscr_get(trans->subscr);
 		/* Assign transaction */
 		trans->lchan = lchan;
 		use_lchan(lchan);
diff --git a/openbsc/src/gsm_04_11.c b/openbsc/src/gsm_04_11.c
index 85fd6b6..43ee816 100644
--- a/openbsc/src/gsm_04_11.c
+++ b/openbsc/src/gsm_04_11.c
@@ -826,6 +826,7 @@ int gsm0411_rcv_sms(struct msgb *msg, u_int8_t link_id)
 			/* FIXME: send some error message */
 			return -ENOMEM;
 		}
+		subscr_get(lchan->subscr);
 		trans->sms.cp_state = GSM411_CPS_IDLE;
 		trans->sms.rp_state = GSM411_RPS_IDLE;
 		trans->sms.is_mt = 0;
@@ -927,6 +928,7 @@ int gsm411_send_sms_lchan(struct gsm_lchan *lchan, struct gsm_sms *sms)
 		/* FIXME: send some error message */
 		return -ENOMEM;
 	}
+	subscr_get(lchan->subscr);
 	trans->sms.cp_state = GSM411_CPS_IDLE;
 	trans->sms.rp_state = GSM411_RPS_IDLE;
 	trans->sms.is_mt = 1;
diff --git a/openbsc/src/transaction.c b/openbsc/src/transaction.c
index 8e2b0b6..170475b 100644
--- a/openbsc/src/transaction.c
+++ b/openbsc/src/transaction.c
@@ -73,7 +73,6 @@ struct gsm_trans *trans_alloc(struct gsm_subscriber *subscr,
 		return NULL;
 
 	trans->subscr = subscr;
-	subscr_get(trans->subscr);
 
 	trans->protocol = protocol;
 	trans->transaction_id = trans_id;
@@ -100,19 +99,6 @@ void trans_free(struct gsm_trans *trans)
 	if (trans->lchan)
 		put_lchan(trans->lchan);
 
-	if (!trans->lchan && trans->subscr && trans->subscr->net) {
-		/* Stop paging on all bts' */
-		bts = NULL;
-		do {
-			bts = gsm_bts_by_lac(trans->subscr->net,
-					     trans->subscr->lac, bts);
-			if (!bts)
-				break;
-			/* Stop paging */
-			paging_request_stop(bts, trans->subscr, NULL);
-		} while (1);
-	}
-
 	if (trans->subscr)
 		subscr_put(trans->subscr);
 
diff --git a/openbsc/src/vty_interface_layer3.c b/openbsc/src/vty_interface_layer3.c
index 032e16f..b9ec7e0 100644
--- a/openbsc/src/vty_interface_layer3.c
+++ b/openbsc/src/vty_interface_layer3.c
@@ -173,7 +173,7 @@ struct gsm_sms *sms_from_text(struct gsm_subscriber *receiver, const char *text)
 		return NULL;
 	}
 
-	sms->receiver = subscr_get(receiver);
+	sms->receiver = receiver;
 	strncpy(sms->text, text, sizeof(sms->text)-1);
 
 	/* FIXME: don't use ID 1 static */
@@ -196,6 +196,10 @@ static int _send_sms_buffer(struct gsm_subscriber *receiver,
 	struct gsm_sms *sms;
 
 	sms = sms_from_text(receiver, buffer_getstr(b));
+	if (!sms) {
+		subscr_put(receiver);
+		return CMD_WARNING;
+	}
 
 	gsm411_send_sms_subscr(receiver, sms);
 
